/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * DlgImportProcessError.java
 *
 * Created on 17-abr-2009, 17:30:16
 */
package es.uca.xmleye.gui;

import java.util.Locale;
import java.util.ResourceBundle;
import javax.swing.ImageIcon;
import javax.swing.JComponent;
import javax.swing.KeyStroke;

/**
 * Specific dialog for showing in further detail why some XML
 * conversion failed. In particular, it shows the return code,
 * collected stdout, and collected stderr.
 *
 * @author Antonio García Domínguez
 * @version 1.0
 */
public class DlgImportProcessError extends javax.swing.JDialog {

  private static final long serialVersionUID = 1;
  private static final ResourceBundle res;
  private int statusCode = 0;

  static {
    res = ResourceBundle.getBundle(
        "es.uca.xmleye.gui.l10n.ResDlgImportProcessError",
        Locale.getDefault());
  }

  /** Creates new form DlgImportProcessError */
  public DlgImportProcessError(java.awt.Frame parent, boolean modal) {
    super(parent, modal);
    initComponents();
    initKeyboardShortcuts();
    setLocationRelativeTo(parent);
    setStatusCode(0);
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {
    java.awt.GridBagConstraints gridBagConstraints;

    lblStderr = new javax.swing.JLabel();
    lblStdout = new javax.swing.JLabel();
    lblDialogIcon = new javax.swing.JLabel();
    scrStdout = new javax.swing.JScrollPane();
    txtStdout = new javax.swing.JTextArea();
    scrStderr = new javax.swing.JScrollPane();
    txtStderr = new javax.swing.JTextArea();
    txtDialogMessage = new javax.swing.JTextArea();
    btnClose = new javax.swing.JButton();

    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    setTitle(res.getString("dlg_title"));
    setMinimumSize(new java.awt.Dimension(350, 400));
    getContentPane().setLayout(new java.awt.GridBagLayout());

    lblStderr.setText(res.getString("lbl_stderr"));
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 0;
    gridBagConstraints.gridy = 3;
    gridBagConstraints.gridwidth = 2;
    gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
    gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
    gridBagConstraints.weightx = 1.0;
    gridBagConstraints.insets = new java.awt.Insets(18, 8, 4, 8);
    getContentPane().add(lblStderr, gridBagConstraints);

    lblStdout.setText(res.getString("lbl_stdout"));
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 0;
    gridBagConstraints.gridy = 1;
    gridBagConstraints.gridwidth = 2;
    gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
    gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
    gridBagConstraints.weightx = 1.0;
    gridBagConstraints.insets = new java.awt.Insets(18, 8, 4, 8);
    getContentPane().add(lblStdout, gridBagConstraints);

    lblDialogIcon.setIcon(new ImageIcon(res.getString("dlg_icon")));
    lblDialogIcon.setText("");
    lblDialogIcon.setIconTextGap(8);
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 0;
    gridBagConstraints.gridy = 0;
    gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
    gridBagConstraints.insets = new java.awt.Insets(8, 8, 0, 12);
    getContentPane().add(lblDialogIcon, gridBagConstraints);

    scrStdout.setPreferredSize(new java.awt.Dimension(500, 125));

    txtStdout.setLineWrap(true);
    txtStdout.setWrapStyleWord(true);
    txtStdout.setColumns(120);
    txtStdout.setEditable(false);
    txtStdout.setRows(5);
    txtStdout.setMinimumSize(new java.awt.Dimension(200, 100));
    scrStdout.setViewportView(txtStdout);

    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 0;
    gridBagConstraints.gridy = 2;
    gridBagConstraints.gridwidth = 2;
    gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
    gridBagConstraints.weightx = 1.0;
    gridBagConstraints.weighty = 0.5;
    gridBagConstraints.insets = new java.awt.Insets(4, 8, 0, 8);
    getContentPane().add(scrStdout, gridBagConstraints);

    scrStderr.setPreferredSize(new java.awt.Dimension(500, 125));

    txtStderr.setColumns(120);
    txtStderr.setLineWrap(true);
    txtStderr.setWrapStyleWord(true);
    txtStderr.setEditable(false);
    txtStderr.setRows(5);
    txtStderr.setMinimumSize(new java.awt.Dimension(200, 100));
    scrStderr.setViewportView(txtStderr);

    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 0;
    gridBagConstraints.gridy = 4;
    gridBagConstraints.gridwidth = 2;
    gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
    gridBagConstraints.weightx = 1.0;
    gridBagConstraints.weighty = 0.5;
    gridBagConstraints.insets = new java.awt.Insets(4, 8, 8, 8);
    getContentPane().add(scrStderr, gridBagConstraints);

    txtDialogMessage.setColumns(20);
    txtDialogMessage.setEditable(false);
    txtDialogMessage.setFont(new java.awt.Font("SansSerif", 0, 13)); // NOI18N
    txtDialogMessage.setLineWrap(true);
    txtDialogMessage.setRows(2);
    txtDialogMessage.setText("placeholder for message\ncheck layout with multiline");
    txtDialogMessage.setWrapStyleWord(true);
    txtDialogMessage.setAutoscrolls(false);
    txtDialogMessage.setFocusable(false);
    txtDialogMessage.setOpaque(false);
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
    gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
    gridBagConstraints.weightx = 1.0;
    gridBagConstraints.insets = new java.awt.Insets(8, 0, 0, 8);
    getContentPane().add(txtDialogMessage, gridBagConstraints);

    btnClose.setText(res.getString("btn_close"));
    btnClose.setMaximumSize(new java.awt.Dimension(100, 25));
    btnClose.setMinimumSize(new java.awt.Dimension(60, 25));
    btnClose.setPreferredSize(new java.awt.Dimension(80, 25));
    btnClose.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(java.awt.event.ActionEvent evt) {
          btnCloseActionPerformed(evt);
        }
      });
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 1;
    gridBagConstraints.gridy = 5;
    gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
    gridBagConstraints.insets = new java.awt.Insets(4, 0, 8, 8);
    getContentPane().add(btnClose, gridBagConstraints);

    pack();
  }// </editor-fold>//GEN-END:initComponents

  private void btnCloseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCloseActionPerformed
    this.setVisible(false);
    this.dispose();
  }//GEN-LAST:event_btnCloseActionPerformed

  /**
   * @param args the command line arguments
   */
  public static void main(String args[]) {
    java.awt.EventQueue.invokeLater(new Runnable() {

        public void run() {
          DlgImportProcessError dialog = new DlgImportProcessError(
              new javax.swing.JFrame(), true);
          dialog.addWindowListener(new java.awt.event.WindowAdapter() {

              @Override
            public void windowClosing(java.awt.event.WindowEvent e) {
                System.exit(0);
              }
            });
          dialog.setStatusCode(5);
          dialog.setStderr(
              "Really long text goes here. Really long text goes here." +
              "Really long text goes here.Really long text goes here." +
              "Really long text goes here.Really long text goes here." +
              "Really long text goes here.Really long text goes here." +
              "Really long text goes here. Really long text goes here." +
              "Really long text goes here.Really long text goes here." +
              "Really long text goes here.Really long text goes here." +
              "Really long text goes here.Really long text goes here.\n" +
              "Really long text goes here.Really long text goes here." +
              "Really long text goes here.");
          dialog.setStdout("Long stdout here. Long stdout here." +
                           "Long stdout here.Long stdout here. Long stdout." +
                           "Long stdout here.Long stdout here.\n" +
                           "Long stdout here.Long stdout here. Long stdout." +
                           " Long stdout here.Long stdout here.\n" +
                           "Long stdout here.Long stdout here. Long stdout here.");
          dialog.setVisible(true);
        }
      });
  }

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton btnClose;
  private javax.swing.JLabel lblDialogIcon;
  private javax.swing.JLabel lblStderr;
  private javax.swing.JLabel lblStdout;
  private javax.swing.JScrollPane scrStderr;
  private javax.swing.JScrollPane scrStdout;
  private javax.swing.JTextArea txtDialogMessage;
  private javax.swing.JTextArea txtStderr;
  private javax.swing.JTextArea txtStdout;
  // End of variables declaration//GEN-END:variables

  /**
   * Getter for the status code displayed.
   * @return Status code which will be reported to the user as part of
   * the dialog's message.
   */
  public int getStatusCode() {
    return statusCode;
  }

  /**
   * @param statusCode the statusCode to set
   */
  public void setStatusCode(int statusCode) {
    this.statusCode = statusCode;
    txtDialogMessage.setText(String.format(res.getString("dlg_message"),
                                           getStatusCode()));
  }

  /**
   * Getter for the saved contents of stderr.
   * @return Text currently displayed in the stderr area.
   */
  public String getStderr() {
    return txtStderr.getText();
  }

  /**
   * Changes the text displyaed for stderr.
   * @param New text to fill the area for the standard error output of
   * the import process.
   */
  public void setStderr(String sStdout) {
    txtStderr.setText(sStdout);
  }

  /**
   * Getter for the saved contents of stdout.
   * @return Text currently displayed in the stdout area.
   */
  public String getStdout() {
    return txtStdout.getText();
  }

  /**
   * Changes the text displyaed for stdout.
   * @param New text to fill the area for the standard output of the
   * import process.
   */
  public void setStdout(String sStderr) {
    txtStdout.setText(sStderr);
  }

  private void initKeyboardShortcuts() {
    // RETURN and ESCAPE should exit the dialog
    getRootPane().setDefaultButton(btnClose);
    btnClose.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(
        KeyStroke.getKeyStroke("ESCAPE"), "click");
  }
}
