package es.uca.xmleye.gui.l10n;

/*
 Copyright (C) 2005-2008 Antonio García Domínguez

 This program is free software; you can redistribute it 
 and/or modify it under the terms of the GNU General Public 
 License as published by the Free Software Foundation; 
 either version 2 of the License, or (at your option) any 
 later version.

 This program is distributed in the hope that it will be 
 useful, but WITHOUT ANY WARRANTY; without even the implied 
 warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
 PURPOSE. See the GNU General Public License for more 
 details.

 You should have received a copy of the GNU General Public 
 License along with this program; if not, write to the Free 
 Software Foundation, Inc., 59 Temple Place, Suite 330, 
 Boston, MA 02111-1307 USA
 */

import java.awt.event.KeyEvent;
import java.util.ListResourceBundle;
import java.util.Locale;
import java.util.ResourceBundle;

/**
 * Default locale information (English) for
 * {@link es.uca.xmleye.gui.WndFormats}.
 */
public class ResWndFormats extends ListResourceBundle {
	@Override
	public Object[][] getContents() {
		return contenido;
	}

	private static Object[][] contenido = {
			{ "wnd_formats", "Document Formats" },

			{ "cmd_restore", "Restore" },
			{ "cmd_restore_d",
					"Restores settings back to their default values" },
			{ "cmd_restore_m", new Integer(KeyEvent.VK_R) },

			{ "cmd_ok", "OK" },
			{ "cmd_ok_d", "Saves changes to disk and closes the dialog" },

			{ "cmd_cancel", "Cancel" },
			{ "cmd_cancel_d", "Closes the dialog without saving any changes" },

			{ "lbl_opencmd", "Open command:" },
			{ "lbl_opencmd_m", new Character('a') },
			{ "lbl_editcmd", "Edit command:" },
			{ "lbl_editcmd_m", new Character('c') },
			{ "lbl_formatname", "Format name:" },
			{ "lbl_formatname_m", new Character('t') },
			{ "lbl_extensions", "Extensions (spaced by commas):" },
			{ "lbl_extensions_m", new Character('x') },
			

	};

	// For testing
	public static void main(String[] args) {

		// Print all the values
		for (int i = 0; i < contenido.length; ++i) {
			System.out.println(contenido[i][0] + " = " + contenido[i][1]);
		}

		// Now try extracting them
		ResourceBundle rb = ResourceBundle.getBundle(
				"es.uca.xmleye.ResVentanaTipos", Locale.getDefault());
		for (int i = 0; i < contenido.length; ++i) {
			System.out.println(contenido[i][0] + " = "
					+ rb.getObject((String) contenido[i][0]));
		}
	}
}
