package es.uca.xmleye.prefs;

/*
 Copyright (C) 2008 Antonio García Domínguez

 This program is free software; you can redistribute it 
 and/or modify it under the terms of the GNU General Public 
 License as published by the Free Software Foundation; 
 either version 2 of the License, or (at your option) any 
 later version.

 This program is distributed in the hope that it will be 
 useful, but WITHOUT ANY WARRANTY; without even the implied 
 warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
 PURPOSE. See the GNU General Public License for more 
 details.

 You should have received a copy of the GNU General Public 
 License along with this program; if not, write to the Free 
 Software Foundation, Inc., 59 Temple Place, Suite 330, 
 Boston, MA 02111-1307 USA
 */

/**
 * Proxy para un valor booleano guardado en preferencias.
 */
public class PreferenceBackedBoolean {
	private final static String VERDADERO = "true";
	private final static String FALSO = "false";

	private PreferencesManager gPrefs;
	private String clave;
	private boolean omision;

	public PreferenceBackedBoolean(PreferencesManager gPrefs, String clave, boolean omision) {
		this.gPrefs = gPrefs;
		this.clave = clave;
		this.omision = omision;
	}

	public boolean get() {
		return gPrefs.getScalarPref(clave, omision ? VERDADERO : FALSO)
				.equals(VERDADERO);
	}

	public void set(boolean b) {
		gPrefs.setScalarPref(clave, b ? VERDADERO : FALSO);
	}
}
